#include 'protheus.ch'
#define  CTRL_CAMPOS  1    // Cantidad de campos del regristo  count
/*/


Ŀ
Funcion    campanha  Autor   Marcio Torresson      Data 20/08/2012
Ĵ
Descrip.   Leitura de arquivo .CSV e importao de dados para o sis-  
           tema Microsiga, lenvando em conta parametros definidos pelo
           cliente													  
Ĵ
 Uso       Generico                                                   
Ĵ
Parametros                                                            
ٱ

/*/
User Function impsb7()

Private nPanel  := 1,;
oDlg, oBmp1, oBmp2, oGet,;
nOpca  := 0,;
cFile  := Space(255),;
cType  := "Todos Arquivos      | *.* ",;
dDatSvd:= dDataBase

DEFINE DIALOG oDlg FROM 000,000 TO 320,480 TITLE OemToAnsi('Importao de Inventario') PIXEL
@ 035, 050 TO 140, 230 OF oDlg PIXEL
@ 000, 050 BITMAP oBmp1 RESNAME "APLOGO" OF oDlg SIZE 100,200 NOBORDER  WHEN .F. PIXEL
@ 000, 000 BITMAP oBmp2 RESNAME "LOGIN"  OF oDlg SIZE 050,155 NOBORDER  WHEN .F. PIXEL
@ 120,070 MSGET oGet VAR cFile SIZE 125,10 PIXEL OF oDlg
@ 120,200 BUTTON OemToAnsi("...") SIZE 15,10 PIXEL OF oDlg ACTION cFile := Padr( cGetFile(cType, OemToAnsi("Selecionando o arquivo "+Subs(cType,1,6)),0,,.T.,GETF_LOCALHARD+GETF_LOCALFLOPPY+GETF_NETWORKDRIVE), 255 )

DEFINE SBUTTON FROM  145, 170 TYPE 1 ACTION (nOpca := 1, oDlg:End()) ENABLE PIXEL OF oDlg
DEFINE SBUTTON FROM  145, 200 TYPE 2 ACTION (nOpca := 0, oDlg:End()) ENABLE PIXEL OF oDlg
ACTIVATE DIALOG oDlg CENTERED

If nOpca == 1
	Processa( { || ProcCli( ) }, 'Procesando Arquivo...' )
	Aviso(OemToAnsi("Confirmao"),"Processo Finalizado",{"Ok"},1)
EndIf

dDataBase   := dDatSvd

Return

/*/


Ŀ
Funcin                Autor                       Data           
Ĵ
Descripcin                                                           
Ĵ
 Uso                                                                  
ٱ


/*/
Static Function ProcCli( )
Local cEOF      := Chr(13) + Chr(10),;
nByte     := 0,;
nX        := 0,;
nZ        := 0,;
nMaxLin   := 100,;
nTamFile  := 0,;
nHnd, cString,;
lOk       := .F.,;
lRet      := .F.,;
cFileLog  := "",;
cPath     := "",;
nReg      := 1,;
aVals     := {},;
aDocs     := {},;
nFila     := 0,;
aError    := {},;
xControle := 0,;
xCtrlGrava := 0,;
lgrava    := .t.,;
xReg      := 0,;
xgravado  := 0,;
cCodRelac := "",;
xGravaRel := 0,;
aDados    := {}

Private _cDirDocs   := MsDocPath()
Private _cPath		:= AllTrim(GetTempPath())
Private _cArquivo  	:= CriaTrab(,.F.)+".CSV"

nHnd  := FOpen( Alltrim( Lower( cFile ) ) )
If nHnd == -1
	Aviso("Falha de Abertura", "Ouve uma falha na abertura do arquivo.", {"Ok"}, 1 )
	DbCloseArea("TRB")
	Return( .F. )
EndIf

cFile := Alltrim( Lower( cFile ) )

nTamFile := FSeek( nHnd, 0, 2 )
FSeek( nHnd, 0, 0 )

AutoGrLog( "Data Inicio.......: " + Dtoc(MsDate()) )
AutoGrLog( "Hora Inicio........: " + Time() )
AutoGrLog( "Environment........: " + GetEnvServer() )
AutoGrLog( "Usuario............: " + SubStr( cUsuario, 7, 15 ) )
AutoGrLog( "Arquivo............: " + Alltrim( Lower( cFile ) ) )
AutoGrLog( " " )

ProcRegua(400)

While nByte < nTamFile
	
	nFila += 1
	IncProc( 'Processando Fila: '+ alltrim(str(nFila,12,0)))
	
	cString  := Space( nMaxLin )
	nRead    := FRead( nHnd, @cString, nMaxLin )
	nPos     := At( cEOF, cString )
	If nPos != 0
		nByte += ( nPos + 1 )
		FSeek( nHnd, nByte, 0 )
		cResult  := SubStr( cString, 1, nPos - 1 )
	Else
		nByte := nTamFile
		cResult  := SubStr( cString, 1, nPos - 1 )
	EndIf
	
	aVals     := Str2Array( cResult, ';' )
	nLenField := Len( aVals )             
	
	lOk       := .T.
	
	If nLenField < CTRL_CAMPOS
		AutoGrLog( "ERROR Processando a fila: " + strzero( nFila, 4)+"-"+avals[1] )
		lgrava := .f.
		Loop
	EndIf

    dbselectarea("SB7")
	reclock("SB7",.t.)
	b7_filial := xFilial("SB7")
	b7_cod    := avals[01]
	b7_local  := avals[02]
	b7_tipo   := posicione("SB1",1,xfilial("SB1")+avals[01],"B1_TIPO")
	b7_doc    := avals[03]
	b7_quant  := val(avals[05])
	b7_data   := ctod(avals[04])
	b7_dtvalid := ctod(avals[04])
	msunlock()

EndDo

FClose( nHnd )

AutoGrLog( "  " )
AutoGrLog( "Data Final..........: " + Dtoc(MsDate()) )
AutoGrLog( "Hora Final...........: " + Time() )

cFileLog := NomeAutoLog()

If cFileLog <> ""
	nX := 1
	While .t.
		If File( Lower( '\spool\' + Dtos( MSDate() ) + StrZero( nX, 3 ) + '.log' ) ) // El directorio debe estar creado en el servidor bajo DATA
			nX++
			If nX == 999
				Exit
			EndIf
			Loop
		Else
			Exit
		EndIf
	EndDo
	__CopyFile( cPath + Alltrim( cFileLog ), Lower( '\spool\' + Dtos( MSDate() ) + StrZero( nX, 3 ) + '.log' ) )
	MostraErro(cPath,cFileLog)
	FErase( cFileLog )
Endif

Return

/*/



Ŀ
Funcin                Autor                       Data           
Ĵ
Descripcin                                                           
Ĵ
 Uso                                                                  
ٱ


/*/
Static Function TudoOk()
Local nHnd

Return( .T. )


/*/


Ŀ
Funcin                Autor                       Data           
Ĵ
Descripcin                                                           
Ĵ
 Uso                                                                  
ٱ


/*/
Static Function Str2Array( cString, cSep )

Local aReturn := { },;
cAux    := cString,;
nPos    := 0,;
nVirg   := 0

While At( cSep, cAux ) > 0
	nPos  := At( cSep, cAux )
	cVal  := SubStr( cAux, 1, nPos-1 )
	nVirg := at(",",cVal)
	if nVirg > 0
		cVal := substr(cVal,1,nVirg-1)+"."+substr(cVal,nVirg+1,len(cVal))
	endif
	Aadd( aReturn,  cVal )
	cAux  := SubStr( cAux, nPos+1 )
EndDo   

nVirg := at(",",cAux)
if nVirg > 0
	cAux := substr(cAux,1,nVirg-1)+"."+substr(cAux,nVirg+1,len(cAux))
endif

Aadd( aReturn, cAux )

Return( aReturn )